(function () {
    'use strict';

    class GameData {
        static InitData(successcallback) {
            var playerData = Laya.LocalStorage.getItem("playerData");
            if (playerData) {
                console.log("============老用户============");
                GameData.playerData = JSON.parse(playerData);
                var day = new Date().getDate();
                if (GameData.playerData.curDay != day) {
                    console.log("============新的一天============");
                    GameData.playerData.curDay = day;
                }
            } else {
                console.log("============新用户============");
            }
            Laya.timer.loop(500, this, GameData.AutoSaveData);

            var config = [
                "res/JSON/arms.json",
            ];

            Laya.loader.load(config, Laya.Handler.create(this, function () {
                for (var key in config) {
                    GameData.JSONData = Laya.loader.getRes(config[key]);
                }
                console.log("JSONData:", GameData.JSONData);
                successcallback();
            }));
        }

        static SaveData() {
            var playerData = JSON.stringify(GameData.playerData);
            Laya.LocalStorage.setItem("playerData", playerData);
        }

        static GetData(key) {
            return GameData.playerData[key];
        }

        static SetData(key, value) {
            GameData.playerData[key] = value;
            GameData.AutoSave = true;
        }

        static AutoSaveData() {
            if (GameData.AutoSave) {
                GameData.SaveData();
                GameData.AutoSave = false;
            }
        }

        static getOneJSONData(JSONindex, index) {
            return GameData.JSONData[JSONindex][index];
        }

        static searchJSONData(modeName) {
            for (var key in GameData.JSONData) {
                if (GameData.JSONData[key].modeName == modeName) {
                    return GameData.JSONData[key];
                }
            }
            return null;
        }
    }
    GameData.AutoSave = true;//自动保存标识
    GameData.playerData = {
        "yssm": 0,              //隐私声明
        "curDay": 0,            //日期
        "sound": 1
    };
    GameData.JSONData = null;

    class GameManager {
        static OpenSound() {
            Laya.SoundManager.muted = false;
        }

        static CloseSound() {
            Laya.SoundManager.muted = true;
        }

        static PlaySound(name, loop = 1, volume = 1) {
            if (GameData.GetData("sound") == 0) {
                return;
            }
            var sn = "res/Music/" + name + ".mp3";
            Laya.loader.load(sn, Laya.Handler.create(this, () => {
                Laya.SoundManager.playSound(sn, loop).volume = volume;
                if (GameManager.hasPlayedSound.indexOf(sn) == -1) {
                    GameManager.hasPlayedSound.push(sn);
                    Laya.SoundManager.playSound(sn, loop).volume = volume;
                }
            }));
        }

        static PlayMusic(name) {
            Laya.SoundManager.stopAll();
            var sn = "res/Music/" + name + ".mp3";
            Laya.loader.load(sn, Laya.Handler.create(this, () => {
                Laya.SoundManager.playMusic(sn, 0);
                if (GameManager.hasPlayedSound.indexOf(sn) == -1) {
                    GameManager.hasPlayedSound.push(sn);
                    Laya.SoundManager.playMusic(sn, 0);
                }
                if (GameData.GetData("sound") == 0) {
                    GameManager.CloseSound();
                }
            }));
        }

        static Random(min, max) {
            return Math.floor(Math.random() * (max + 1 - min)) + min;
        }

        static getJSONLength(json) {
            var length = 0;
            for (var key in json) {
                length++;
            }
            return length;
        }

        static getNPCBornPoint(pointName) {
            for (var key in GameManager.npcBornPointJS) {
                if (GameManager.npcBornPointJS[key].name == pointName) {
                    return GameManager.npcBornPointJS[key];
                }
            }
            return null;
        }

        static createRay(NPC) {
            let tmp = new Laya.Vector3(0, 0, 0);
            Laya.Vector3.subtract(GameManager.player.transform.position, NPC.transform.position, tmp);
            let dst = new Laya.Vector3(0, 0, 0);
            Laya.Vector3.normalize(tmp, dst);
            let _ray = new Laya.Ray(NPC.transform.position, dst);
            var outHitRusult = new Laya.HitResult();
            GameManager.Scene.physicsSimulation.rayCast(_ray, outHitRusult);

            if (outHitRusult.succeeded) {
                var name = outHitRusult.collider.owner.name;
                if (name == "role1") {
                    return true;
                }
            }
            return false;
        }

        static createRay_player(distance) {
            let point = new Laya.Vector2(0, 0);
            point.x = Laya.stage.width / 2;
            point.y = Laya.stage.height / 2;

            var _ray = new Laya.Ray(new Laya.Vector3(0, 0, 0), new Laya.Vector3(0, 0, 0));
            GameManager.Camera.getChildByName("Camera").viewportPointToRay(point, _ray);
            var outHitRusult = new Laya.HitResult();
            GameManager.Scene.physicsSimulation.rayCast(_ray, outHitRusult, distance * 4);

            if (outHitRusult.succeeded) {
                var name = outHitRusult.collider.owner.name;
                if (name.indexOf("npc") != -1) {
                    return name;
                }
            }
            return null;
        }

        static getAngle(NPC) {
            let tmp = new Laya.Vector3(0, 0, 0);
            Laya.Vector3.subtract(GameManager.player.transform.position, NPC.transform.position, tmp);
            let dst = new Laya.Vector3(0, 0, 0);
            Laya.Vector3.normalize(tmp, dst);

            let forward = new Laya.Vector3(0, 0, 0);
            GameManager.player.transform.getForward(forward);

            var cosX = (dst.x * forward.x + dst.z * forward.z) / (Math.sqrt(GameManager.powVect(dst)) * Math.sqrt(GameManager.powVect(forward)));
            var angle = Math.acos(cosX) / (Math.PI / 180);

            var direction = dst.x * forward.z - dst.z * forward.x;
            if (direction < 0) {
                return angle;
            } else {
                return -angle;
            }
        }

        static vectorAngle(x, y) {
            let mX = Math.sqrt(x.reduce((acc, n) => acc + Math.pow(n, 2), 0));
            let mY = Math.sqrt(y.reduce((acc, n) => acc + Math.pow(n, 2), 0));
            return Math.acos(x.reduce((acc, n, i) => acc + n * y[i], 0) / (mX * mY));
        }

        static powVect(vect) {
            var pow = Math.pow(vect.x, 2) + Math.pow(vect.z, 2);
            return pow;
        }

        static getNPCJS(name) {
            for (var key in GameManager.npcJS) {
                if (GameManager.npcJS[key].name == name) {
                    return GameManager.npcJS[key];
                }
            }
            return null;
        }

    }
    ///////////////////////////////////////////////////////////////////////////////////////
    //模型
    GameManager.resScene = null;
    GameManager.Scene = null;
    GameManager.Model = null;
    GameManager.Camera = null;
    GameManager.playBornPoint = null;
    GameManager.player = null;
    ///////////////////////////////////////////////////////////////////////////////////////
    //模型脚本
    GameManager.CameraJS = null;
    GameManager.playerJS = null;
    GameManager.npcBornPointJS = [];
    GameManager.npcJS = [];
    GameManager.hasPlayedSound = [];
    GameManager.canShoot = true;
    ///////////////////////////////////////////////////////////////////////////////////////
    //游戏参数和flag
    GameManager.rotateSpeed = 0.05;
    GameManager.shootTime = 0;
    GameManager.shootTimer = null;
    GameManager.showTipTimer = null;
    GameManager.moveCameraTimer = null;
    GameManager.areaNum = [8, 8, 8, 8];
    GameManager.isAim = false;
    GameManager.hitProbability = 10;
    GameManager.noHarm = false;
    GameManager.allNum = 0;
    ///////////////////////////////////////////////////////////////////////////////////////
    //场景脚本
    GameManager.gameScene = null;

    class gameScene extends Laya.Scene {

        constructor() {
            super();
            this.selectCell = null;
        }

        onEnable() {
            GameManager.gameScene = this;
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
            this.InitBtn();
            this.InitFlag();
            Laya.timer.loop(1, this, this.update);
            console.log("sound:" + GameData.GetData("sound"));
        }

        InitBtn() {
            this.shootBtn.on(Laya.Event.MOUSE_DOWN, this, this.shootBtnDown);
            this.aimBtn.on(Laya.Event.CLICK, this, this.clickAim);
            this.settingBtn.on(Laya.Event.MOUSE_DOWN, this, function () {
                GameManager.isPause = true;
                this.settingUI.visible = true;
                console.log("sound:" + GameData.GetData("sound"));
                if (GameData.GetData("sound") == 1) {
                    this.musicSettingBtn.selectedIndex = 0;
                } else {
                    this.musicSettingBtn.selectedIndex = 1;
                }
            });
            this.settingCloseBtn.on(Laya.Event.CLICK, this, function () {
                GameManager.isPause = false;
                this.settingUI.visible = false;
            });
            this.reStartBtn.on(Laya.Event.CLICK, this, this.clickRestart);
            this.mainBtn1.on(Laya.Event.CLICK, this, function () {
                Laya.Scene.open("scene/mainScene.scene");
            });
            this.musicSettingBtn.on(Laya.Event.CLICK, this, function () {
                if (this.musicSettingBtn.selectedIndex == 0) {
                    GameManager.OpenSound();
                    GameData.SetData("sound", 1);
                } else if (this.musicSettingBtn.selectedIndex == 1) {
                    GameManager.CloseSound();
                    GameData.SetData("sound", 0);
                }
            });
            this.bushuBtn.on(Laya.Event.CLICK, this, this.clickBuShu);
            this.mainBtn2.on(Laya.Event.CLICK, this, function () {
                Laya.Scene.open("scene/mainScene.scene");
            });
            this.fireTypeBtn.on(Laya.Event.CLICK, this, function () {
                GameManager.playerJS.armJS.changeFire();
            });
            this.magazineBtn.on(Laya.Event.CLICK, this, function () {
                GameManager.playerJS.magazine();
            });

            this.InitReadyList();
        }

        clickRestart() {
            Laya.Scene.open("scene/mainScene.scene", true, true);
        }

        InitReadyList() {
            if (this.selectCell != null) {
                this.selectCell.getChildByName("isSelect").visible = false;
                this.describeUI.visible = false;
            }

            this.BtnUI.visible = false;
            this.readyUI.visible = true;

            this.armList.vScrollBarSkin = "";
            this.armList.renderHandler = new Laya.Handler(this, this.updateReadyList);
            this.armList.array = [];
            let array = [];
            for (var key in GameData.JSONData) {
                let obj = {};
                obj['armID'] = { text: key };
                obj['armPic'] = { skin: "readyScene/" + GameData.JSONData[key].listPic + ".png" };
                obj['armName'] = { skin: "readyScene/" + GameData.JSONData[key].namePic + ".png" };
                array.push(obj);
            }
            this.armList.array = array;
            this.describeUI.visible = false;
        }

        updateReadyList(cell) {
            let armID = cell.getChildByName("armID").text;
            let armBtn = cell.getChildByName("armBtn");
            armBtn.offAll();
            armBtn.on(Laya.Event.CLICK, this, this.choseArm, [armID, cell]);
        }

        choseArm(armID, cell) {
            if (this.selectCell != null) {
                this.selectCell.getChildByName("isSelect").visible = false;
                this.describeUI.visible = false;
            }
            cell.getChildByName("isSelect").visible = true;
            this.selectCell = cell;

            this.describeUI.visible = true;
            this.describePic.skin = "readyScene/" + GameData.JSONData[armID].describePic + ".png";
            this.pic.skin = "readyScene/" + GameData.JSONData[armID].pic + ".png";
            this.huoliBar.value = GameData.JSONData[armID].harm / 100;
            this.speedBar.value = (100 - GameData.JSONData[armID].speed) / 100;
            this.accuracyBar.value = GameData.JSONData[armID].accuracy / 10;
            this.armNum.text = GameData.JSONData[armID].bulletNum;

            GameManager.playerJS.choseArm(armID);
        }

        InitFlag() {
            var lanflags = GameManager.Scene.getChildByName("flag").getChildByName("lan")._children;
            for (var key in lanflags) {
                lanflags[key].active = false;
            }
        }

        clickBuShu() {
            GameManager.isPause = false;
            this.readyUI.visible = false;
            this.BtnUI.visible = true;
        }

        clickAim() {//瞄准按钮
            GameManager.playerJS.Aim();
        }

        shootBtnDown() {
            if (!GameManager.playerJS.armJS.isRunningFire) {
                GameManager.playerJS.onShoot_one();
            } else {
                if (GameManager.playerJS.armJS != null) {
                    GameManager.playerJS.onShoot_more();
                    GameManager.shootTimer = setInterval(() => {
                        GameManager.playerJS.onShoot_more();
                    }, GameManager.playerJS.armJS.shootTime);
                }
            }
        }

        update() {
            if (GameManager.player != null) {
                this.map.x = GameManager.player.transform.position.x / 792 * 512 + 134;
                this.map.y = GameManager.player.transform.position.z / 814 * 512 + 93;
                this.role.rotation = -GameManager.player.transform.localRotationEulerY - 40;
            }

            this.enemyNum.text = GameManager.allNum;

            if (GameManager.playerJS != null) {
                this.life.text = GameManager.playerJS.life;
                this.lifeBar.value = GameManager.playerJS.life / 100;
                if (GameManager.playerJS.armJS != null) {
                    this.bulletNum.text = GameManager.playerJS.armJS.nowBullet;
                }
            }


            for (var key in this.pointUI._children) {
                if (!this.pointUI._children[key].visible) {
                    return;
                }
            }

            if (!this.successUI.visible) {
                this.BtnUI.visible = false;
                this.successUI.visible = true;
                GameManager.isPause = true;
            }
        }

        onDisable() {
            GameManager.player = null;
            GameManager.playerJS = null;
            GameManager.Scene.destroy();
            GameManager.gameScene = null;
        }
    }

    /**This class is automatically generated by LayaAirIDE, please do not make any modifications. */
    var View=Laya.View;
    var Dialog=Laya.Dialog;
    var Scene=Laya.Scene;
    var REG = Laya.ClassUtils.regClass;
    class gameSceneUI extends Scene {
    	constructor(){ 
    		super();
    	}
    	createChildren() {
    		super.createChildren();
    		this.loadScene("scene/gameScene");
    	}
    }
    REG("ui.scene.gameSceneUI",gameSceneUI);
    class harmUIUI extends View {
    	constructor(){ 
    		super();
    	}
    	createChildren() {
    		super.createChildren();
    		this.loadScene("scene/harmUI");
    	}
    }
    REG("ui.scene.harmUIUI",harmUIUI);
    class loadingSceneUI extends Scene {
    	constructor(){ 
    		super();
    	}
    	createChildren() {
    		super.createChildren();
    		this.loadScene("scene/loadingScene");
    	}
    }
    REG("ui.scene.loadingSceneUI",loadingSceneUI);
    class mainSceneUI extends Scene {
    	constructor(){ 
    		super();
    	}
    	createChildren() {
    		super.createChildren();
    		this.loadScene("scene/mainScene");
    	}
    }
    REG("ui.scene.mainSceneUI",mainSceneUI);
    class RockerViewUI extends View {
    	constructor(){ 
    		super();
    	}
    	createChildren() {
    		super.createChildren();
    		this.loadScene("scene/RockerView");
    	}
    }
    REG("ui.scene.RockerViewUI",RockerViewUI);
    class TranslateViewUI extends View {
    	constructor(){ 
    		super();
    	}
    	createChildren() {
    		super.createChildren();
    		this.loadScene("scene/TranslateView");
    	}
    }
    REG("ui.scene.TranslateViewUI",TranslateViewUI);

    class harmUI extends harmUIUI {

        constructor(angle) {
            super();
            this.zOrder = 100;
            Laya.timer.once(700, this, function () {
                this.destroy();
            });
            this.angle = angle;
        }

        onEnable() {
            this.harmUI.rotation = this.angle;
        }

        onDisable() {
        }
    }

    class SDK_apk {
        static goToMoreGame() {
            if (window.android) {
                window.android.goToMoreGame();
            }
        }

        static showYSSM() {
            if (window.android) {
                window.android.showYSSM();
            }
        }

        static showEmail() {
            if (window.android) {
                window.android.showEmail();
            }
        }

        static showNotice() {
            if (window.android) {
                window.android.showNotice();
            }
        }

        static getLogoUrl() {
            if (window.android) {
                SDK_apk.logoUrl = window.android.getLogoUrl();
                console.log("logo地址：" + SDK_apk.logoUrl);
            }
        }

        static getJPGUrl_loading(index) {
            if (window.android) {
                SDK_apk.JPGUrl_loading = window.android.getJPGUrl_loading(index);
                console.log("JPGUrl_loading地址：" + SDK_apk.JPGUrl_loading);
                return SDK_apk.JPGUrl_loading
            }
        }

        static getJPGUrl_main(index) {
            if (window.android) {
                SDK_apk.logoUrl_main = window.android.getJPGUrl_main(index);
                console.log("logoUrl_main地址：" + SDK_apk.logoUrl_main);
                return SDK_apk.logoUrl_main;
            }
        }

        static getJPGNum_loading() {
            if (window.android) {
                return window.android.getJPGNum_loading();
            }
        }

        static getJPGNum_main() {
            if (window.android) {
                return window.android.getJPGNum_main();
            }
        }

        static random(min, max) {
            return Math.floor(Math.random() * (max + 1 - min)) + min;
        }
    }
    SDK_apk.logoUrl = null;
    SDK_apk.JPGUrl_loading = null;
    SDK_apk.logoUrl_main = null;

    class loadingScene extends Laya.Scene {

        constructor() {
            super();
        }

        onEnable() {
            if (window.android) {
                var jpgIndex = SDK_apk.random(0, SDK_apk.getJPGNum_loading() - 1);
                console.log("jpgIndex:" + jpgIndex);
                var JPGbg = new Laya.Image(SDK_apk.getJPGUrl_loading(jpgIndex));
                JPGbg.zOrder = -1;
                JPGbg.centerX = 0;
                JPGbg.centerY = 0;
                this.addChild(JPGbg);
            }

            this.width = Laya.stage.width;
            this.height = Laya.stage.height;

            this.loadValue = 1;
            this.updateLoadValue = 0;
            Laya.timer.loop(1, this, this.update);
        }

        update() {
            this.updateLoadValue += 0.01;
            if (this.updateLoadValue > this.loadValue) {
                this.updateLoadValue = this.loadValue;
            }
            this.loadBar.value = this.updateLoadValue;

            if (this.loadBar.value >= 1) {
                Laya.timer.clear(this, this.update);

                this.loadStr.text = "正在加载数据";
                GameData.InitData(function () {
                    Laya.Scene.open("scene/mainScene.scene");
                });
            }
        }

        onDisable() {
        }
    }

    class Bullet extends Laya.Script3D {

        constructor() {
            super();
            this.life = 2000;
            this.speedV3 = new Laya.Vector3();
            this.bullet = null;
        }

        onTriggerEnter(other) {

        }

        onCollisionEnter(collision) {
            if (collision.other.owner.name.indexOf("npc") != -1) {
                this.bullet.destroy();
            }
            if (collision.other.owner.name.indexOf("gound") != -1) {
                this.bullet.destroy();
            }
            if (collision.other.owner.name.indexOf("cube") != -1) {
                this.bullet.destroy();
            }
        }

        onEnable() {
            this.bullet = this.owner;
            this.name = this.bullet.name;
        }

        onUpdate() {
            if (!GameManager.isPause) {
                this.bullet.transform.translate(this.speedV3, false);
                this.life--;
                if (this.life < 0) {
                    Laya.timer.frameOnce(1, this, function () { this.bullet.destroy(); });
                }
            }
        }

        setShootDirection(directionV3) {
            Laya.Vector3.normalize(directionV3, this.speedV3);
            Laya.Vector3.scale(this.speedV3, 4, this.speedV3);
        }

        onDisable() {
        }
    }

    class shootfire extends Laya.Script {

        constructor() {
            super();
            this.life = 10;
        }

        onEnable() {
            this.fire = this.owner;
            // this.fire.transform.scale = new Laya.Vector3(0.0001, 0.0001, 0.0001);
        }

        onUpdate() {
            if (!GameManager.isPause) {
                this.life--;
                if (this.life < 0) {
                    Laya.timer.frameOnce(1, this, function () { this.fire.destroy(); });
                }
            }
        }

        onDisable() {

        }
    }

    class Arm extends Laya.Script3D {

        constructor() {
            super();
            this.arm = null;
            this.name = null;
            this.type = null;
            this.bulletNum = 0;
            this.nowBullet = 0;
            this.isRunningFire = false;
            this.shootTime = 1;
            this.harm = 0;
        }

        onEnable() {
            this.arm = this.owner;
            this.name = this.arm.name;
        }

        Init(bulletNum, shootTime, harm) {
            this.bulletNum = bulletNum;
            this.nowBullet = this.bulletNum;
            this.shootTime = shootTime;
            this.harm = harm;
        }

        changeFire() {
            if (this.name == "ju") {
                console.log("狙击枪没有连射");
                return;
            }
            if (this.isRunningFire) {
                this.isRunningFire = false;
                console.log("单点模式");
                GameManager.gameScene.fireTypeBtn.skin = "gameScene/runningFire.png";
            } else {
                this.isRunningFire = true;
                console.log("连射模式");
                GameManager.gameScene.fireTypeBtn.skin = "gameScene/noRunningFire.png";
            }
        }

        onShoot_one(bulletPlay) {
            var bullet = GameManager.Model.getChildByName("bullet");
            var startPos = this.arm._parent.getChildByName("GunshotPos");
            var bulletModel = Laya.Sprite3D.instantiate(bullet, GameManager.Scene);
            bulletModel.name = bulletPlay;
            bulletModel.transform.position = startPos.transform.position;
            var bulletJS = bulletModel.addComponent(Bullet);

            var dirV3 = new Laya.Vector3();
            GameManager.Camera.getChildByName("Camera").transform.getForward(dirV3);

            // //射击的方向向量
            // var dirV3 = new Laya.Vector3();
            // startPos.transform.getForward(dirV3)
            //设置子弹控制脚本中发射方向
            bulletJS.setShootDirection(dirV3);
            this.nowBullet--;

            var Gunshot = GameManager.Model.getChildByName("Gunshot");
            var GunshotPos = this.arm._parent.getChildByName("GunshotPos");
            var GunshotModel = Laya.Sprite3D.instantiate(Gunshot, GunshotPos);
            GunshotModel.transform.localPosition = new Laya.Vector3(0, 0, 0);
            GunshotModel.addComponent(shootfire);
            GameManager.PlaySound(this.name);
        }

        NPCShoot(angle, volume) {
            if (GameManager.playerJS.life > 0) {
                var hitProbability = GameManager.Random(1, 100);
                if (hitProbability <= GameManager.hitProbability) {
                    if (!GameManager.noHarm) {
                        Laya.stage.addChild(new harmUI(angle));
                        GameManager.playerJS.life -= parseInt(this.harm * 0.5);
                        if (GameManager.playerJS.life <= 0) {
                            GameManager.playerJS.Revive();
                        }
                    } else {
                        console.log("已经打开无敌模式");
                    }
                }
                this.nowBullet--;
                GameManager.PlaySound(this.name, 1, volume);

                var Gunshot = GameManager.Model.getChildByName("Gunshot");
                var GunshotPos = this.arm._parent.getChildByName("GunshotPos");
                var GunshotModel = Laya.Sprite3D.instantiate(Gunshot, GunshotPos);
                GunshotModel.transform.localPosition = new Laya.Vector3(0, 0, 0);
                GunshotModel.addComponent(shootfire);
            }
        }

        onDisable() {
        }
    }

    class NPC extends Laya.Script3D {

        constructor() {
            super();
            this.npc = null;
            this.name = null;
            this.armJS = null;
            this.armJSON = null;
            this.life = 100;
            this.point = null;
            this.state = "";
            this.speed = 0.2;
            this.distance = 1000;
            this.times = 0;
        }

        // onCollisionEnter(collision) {
        //     if (collision.other.owner.name.indexOf("bulletPlayer") != -1) {
        //         console.log("NPC碰撞:" + collision.other.owner.name);
        //         this.life -= parseInt(collision.other.owner.name.replace(/[^0-9]/ig, ""));
        //         this.play("hit");
        //         if (this.life <= 0) {
        //             GameManager.getNPCBornPoint(this.point.name).delNPC();
        //         }
        //     }
        // }

        getHarm(harm) {
            this.life -= parseInt(harm);
            this.play("hit");
            if (this.life <= 0) {
                GameManager.getNPCBornPoint(this.point.name).delNPC();
            }
        }

        onEnable() {
            this.npc = this.owner;
            // console.log(this.npc);
            this.name = this.npc.name;
            this.NPCAni = this.npc.getChildByName("npc").getComponent(Laya.Animator);
            this.InitArm();
            this.play("idle");
        }

        Init(point) {
            this.point = point;
        }



        play(aniName) {
            if (this.state != "dle") {
                if (this.state != "magazine") {
                    if (aniName == "hit") {
                        console.log("播放受击动画");
                        this.NPCAni.crossFade(aniName, 0.2, 0);
                        this.state = aniName;
                    } else if (this.state != aniName) {
                        this.NPCAni.crossFade(aniName, 0.2, 0);
                        this.state = aniName;
                    }
                }
            }
        }

        playAttack(aniName) {
            if (this.state != "dle") {
                if (aniName == "aim_attack1") {
                    this.NPCAni.crossFade(aniName, 0.2, 0);
                    this.state = aniName;
                } else {
                    if (this.state != aniName) {
                        this.NPCAni.crossFade(aniName, 0.2, 0);
                        this.state = aniName;
                    }
                }
            }
        }

        InitArm() {
            //为精灵添加角色控制器
            var character = this.npc.addComponent(Laya.CharacterController);
            // console.log(this.npc);
            //创建胶囊碰撞器
            var sphereShape = new Laya.CapsuleColliderShape(0.6, 1.8);
            //设置Shape的本地偏移
            sphereShape.localOffset = new Laya.Vector3(0, 0.8, 0.19);
            //设置角色控制器的碰撞形状
            character.colliderShape = sphereShape;

            var randomArm = GameManager.Random(1, GameManager.getJSONLength(GameData.JSONData) - 1);
            // console.log("randomArm:" + randomArm);
            for (var key in GameData.JSONData) {
                this.npc.getChildByName("npc").getChildByName(GameData.JSONData[key].modeName).active = false;
            }

            var arm = this.npc.getChildByName("npc").getChildByName(GameData.JSONData[randomArm].modeName);
            arm.active = true;
            this.armJS = arm.addComponent(Arm);
            this.armJSON = GameData.searchJSONData(this.armJS.name);
            this.armJS.Init(this.armJSON.bulletNum, this.armJSON.speed, this.armJSON.harm);
        }

        onShoot_one() {
            if (this.armJS != null) {
                this.armJS.onShoot_one("bulletNPC");
            }
        }

        onShoot_more() {
            if (this.armJS != null) {
                this.armJS.onShoot_more("bulletNPC");
            }
        }

        dead() {
            this.state = "";
            this.play("dle");
            setTimeout(() => {
                if (GameManager.gameScene != null) {
                    this.npc.destroy();
                }
            }, 500);
            GameManager.allNum--;
        }

        move() {
            this.npc.transform.translate(new Laya.Vector3(0, 0, -this.speed), true);
        }

        onUpdate() {
            if (this.state != "magazine") {
                this.times++;
                if (!GameManager.isPause) {
                    this.npc.transform.lookAt(GameManager.player.transform.position, new Laya.Vector3(0, 1, 0));

                    this.distance = Laya.Vector3.distance(this.npc.transform.position, GameManager.player.transform.position);
                    if (this.armJSON != null) {
                        if (this.distance <= this.armJSON.shootDis) {
                            if (GameManager.createRay(this.npc)) {
                                var speed = this.armJSON.speed;
                                if (speed == 0) {
                                    speed = 100;
                                }
                                if (this.times % speed * 10 == 0) {
                                    if (this.armJS.nowBullet > 0) {
                                        var angle = GameManager.getAngle(this.npc);
                                        var volume = (100 - this.distance) / 100;
                                        if (this.distance >= 100) {
                                            volume = 0;
                                        }

                                        this.armJS.NPCShoot(angle, volume);
                                        this.playAttack("aim_attack1");
                                    } else {
                                        this.magazine();
                                    }
                                }
                            }
                        } else {
                            if (this.distance < this.armJSON.moveDis && this.distance > this.armJSON.shootDis) {
                                this.play("walk");
                                this.move();
                            }
                        }
                    }
                }
            }
        }

        magazine() {
            this.playAttack("magazine");
            setTimeout(() => {
                this.state = "";
                this.play("idle");
                this.armJS.nowBullet = this.armJS.bulletNum;
            }, 1100);
        }

        onDisable() {

        }
    }

    class NPCBornPoint extends Laya.Script3D {

        constructor() {
            super();
            this.point = null;
            this.name = null;
            this.npcJS = null;
        }

        onEnable() {
            this.point = this.owner;
            this.name = this.point.name;
            this.addNPC();
        }

        addNPC() {
            var npcModel = GameManager.Model.getChildByName("npc2");
            var npc = Laya.Sprite3D.instantiate(npcModel, this.point);
            npc.transform.localPosition = new Laya.Vector3(0, 0, 0);
            npc.name = "npc" + this.name;
            var npcJS = npc.addComponent(NPC);
            this.npcJS = npcJS;
            this.npcJS.Init(this.point);
            GameManager.npcJS.push(this.npcJS);
            GameManager.allNum++;
        }

        delNPC() {
            if (this.npcJS != null) {
                this.npcJS.dead();
                this.npcJS = null;
                var index = parseInt(parseInt(this.name) / 8);
                if (parseInt(this.name) % 8 == 0) {
                    index--;
                }
                GameManager.areaNum[index]--;
                if (GameManager.areaNum[index] <= 0) {
                    index++;
                    GameManager.Scene.getChildByName("flag").getChildByName("hong").getChildByName(index + "").active = false;
                    GameManager.Scene.getChildByName("flag").getChildByName("lan").getChildByName(index + "").active = true;
                    if (GameManager.gameScene != null) {
                        GameManager.gameScene.pointUI.getChildByName("blue" + index).visible = true;
                        if (GameManager.allNum >= 8) {
                            GameManager.gameScene.ani1.play(0, false);
                        }
                    }
                }
            }
        }

        onDisable() {
        }
    }

    class RockerView extends RockerViewUI {

        constructor() {
            super();
        }

        onEnable() {
            this.curTouchId = 0;
            /***手指（鼠标）是否按下****/
            this.isDown = false;
            /***摇杆的角度****/
            this.angle = -1;
            /***摇杆的弧度****/
            this.radians = -1;
            /***是否左手遥控****/
            this.isleftControl = true;
            //鼠标按下事件监听
            Laya.stage.on(Laya.Event.MOUSE_DOWN, this, this.onMouseDown);
            //鼠标抬起事件监听
            Laya.stage.on(Laya.Event.MOUSE_UP, this, this.onMouseUp);
            //鼠标是否移除屏幕事件监听
            // this.touchRect.on(Laya.Event.MOUSE_OUT,this,onBlur);
            //控制器中心点位置初始化
            this.originPiont = new Laya.Point(this.width / 2, this.height / 2);
            //默认为控制器不显示
            this.visible = true;
            this.pos(150, (Laya.stage.height - 300));
        }

        onMouseDown(e) {
            //左右手遥控
            if (this.isleftControl) {
                //如果按下时是右边屏幕位置或已经按下鼠标，则返回
                if (e.stageX > Laya.stage.width / 2 || this.isDown) return;
            }
            else {
                //如果按下时是左边屏幕位置或已经按下鼠标，则返回
                if (e.stageX < Laya.stage.width / 2 || this.isDown) return;
            }
            //记录当前按下id
            this.curTouchId = e.touchId;
            //已按下
            this.isDown = true;
            //更新摇杆到屏幕按下位置
            this.pos(Laya.stage.mouseX - (this.width / 2), Laya.stage.mouseY - (this.height / 2));
            //初始化摇杆控制点位置
            this.knob.pos(this.width / 2, this.height / 2);
            //按下后显示摇杆
            this.visible = true;
            //摇杆移动控制事件监听
            Laya.stage.on(Laya.Event.MOUSE_MOVE, this, this.onMove);
        }

        /*鼠标抬起事件回调*/
        onMouseUp(e) {
            //如果不是上次的点击id，返回（避免多点抬起，以第一次按下id为准）
            if (e.touchId != this.curTouchId) return;
            this.isDown = false;

            this.visible = true;
            //移除摇杆移动事件监听
            Laya.stage.off(Laya.Event.MOUSE_MOVE, this, this.onMove);
            //修改摇杆角度与弧度为-1（代表无角度）
            this.radians = this.angle = -1;

            this.pos(150, (Laya.stage.height - 300));
            this.knob.pos(this.width / 2, this.height / 2);
        }

        /*鼠标移动事件回调*/
        onMove(e) {
            //如果不是上次的点击id，返回（避免多点抬起，以第一次按下id为准）
            if (e.touchId != this.curTouchId) return;
            //将移动时的鼠标屏幕坐标转化为摇杆局部坐标
            var locationPos = this.globalToLocal(new Laya.Point(Laya.stage.mouseX, Laya.stage.mouseY), false);
            //更新摇杆控制点位置
            this.knob.pos(locationPos.x, locationPos.y);
            //更新控制点与摇杆中心点位置距离
            this.deltaX = locationPos.x - this.originPiont.x;
            this.deltaY = locationPos.y - this.originPiont.y;
            //计算控制点在摇杆中的角度
            var dx = this.deltaX * this.deltaX;
            var dy = this.deltaY * this.deltaY;
            this.angle = Math.atan2(this.deltaX, this.deltaY) * 180 / Math.PI;
            if (this.angle < 0) this.angle += 360;
            //对角度取整
            this.angle = Math.round(this.angle);
            //计算控制点在摇杆中的弧度
            this.radians = Math.PI / 180 * this.angle;
            //强制控制点与中心距离不超过80像素
            if (dx + dy >= 80 * 80) {
                //控制点在半径为80像素的位置（根据弧度变化）
                var x = Math.floor(Math.sin(this.radians) * 80 + this.originPiont.x);
                var y = Math.floor(Math.cos(this.radians) * 80 + this.originPiont.y);
                this.knob.pos(x, y);
            }
            else {
                //不超过80像素取原坐标
                this.knob.pos(locationPos.x, locationPos.y);
            }
        }

        onDisable() {
        }
    }

    class TranslateView extends TranslateViewUI {

        constructor() {
            super();
        }

        onEnable() {
            this.curTouchId = 0;
            /***手指（鼠标）是否按下****/
            this.isDown = false;
            /***是否左手遥控****/
            this.isleftControl = false;
            //鼠标按下事件监听
            Laya.stage.on(Laya.Event.MOUSE_DOWN, this, this.onMouseDown);
            //鼠标抬起事件监听
            Laya.stage.on(Laya.Event.MOUSE_UP, this, this.onMouseUp);
            //默认为控制器不显示
            this.visible = false;

            this.deltaX = 0;
            this.deltaY = 0;

            this.lastX = -1;
            this.lastY = -1;
        }

        onMouseDown(e) {
            //左右手遥控
            if (this.isleftControl) {
                //如果按下时是右边屏幕位置或已经按下鼠标，则返回
                if (e.stageX > Laya.stage.width / 2 || this.isDown) return;
            }
            else {
                //如果按下时是左边屏幕位置或已经按下鼠标，则返回
                if (e.stageX < Laya.stage.width / 2 || this.isDown) return;
            }
            //记录当前按下id
            this.curTouchId = e.touchId;
            //已按下
            this.isDown = true;
            //更新摇杆到屏幕按下位置
            this.pos(Laya.stage.mouseX - (this.width / 2), Laya.stage.mouseY - (this.height / 2));

            this.lastX = Laya.stage.mouseX;
            this.lastY = Laya.stage.mouseY;

            //初始化摇杆控制点位置
            this.knob.pos(this.width / 2, this.height / 2);
            //按下后显示摇杆
            this.visible = true;
            //摇杆移动控制事件监听
            Laya.stage.on(Laya.Event.MOUSE_MOVE, this, this.onMove);
        }

        /*鼠标抬起事件回调*/
        onMouseUp(e) {
            //如果不是上次的点击id，返回（避免多点抬起，以第一次按下id为准）
            if (e.touchId != this.curTouchId) return;
            this.isDown = false;
            this.visible = false;
            //移除摇杆移动事件监听
            Laya.stage.off(Laya.Event.MOUSE_MOVE, this, this.onMove);

            this.deltaX = 0;
            this.deltaY = 0;

            clearInterval(GameManager.shootTimer);
            if (GameManager.playerJS != null) {
                GameManager.playerJS.play("idle");
            }
        }

        /*鼠标移动事件回调*/
        onMove(e) {
            if (!GameManager.isPause) {
                //如果不是上次的点击id，返回（避免多点抬起，以第一次按下id为准）
                if (e.touchId != this.curTouchId) return;
                //将移动时的鼠标屏幕坐标转化为摇杆局部坐标
                var locationPos = this.globalToLocal(new Laya.Point(Laya.stage.mouseX, Laya.stage.mouseY), false);
                //更新摇杆控制点位置
                this.knob.pos(locationPos.x, locationPos.y);
                //更新控制点与摇杆中心点位置距离
                this.deltaX = Laya.stage.mouseX - this.lastX;
                this.deltaY = Laya.stage.mouseY - this.lastY;

                this.lastX = Laya.stage.mouseX;
                this.lastY = Laya.stage.mouseY;

                GameManager.Camera.transform.rotate(new Laya.Vector3(this.deltaY * GameManager.rotateSpeed, 0, 0), true, false);

                GameManager.player.transform.rotate(new Laya.Vector3(0, -this.deltaX * GameManager.rotateSpeed, 0), true, false);

                if (GameManager.Camera.transform.localRotation.x > 0.5) {
                    GameManager.Camera.transform.localRotation.x = 0.5;
                    return;
                }

                if (GameManager.Camera.transform.localRotation.x < -0.2) {
                    GameManager.Camera.transform.localRotation.x = -0.2;
                    return;
                }
            }
        }

        onDisable() {

        }
    }

    class Player extends Laya.Script3D {

        constructor() {
            super();
            this.player = null;
            this.name = null;
            this.armJS = null;
            this.armJSON = null;
            this.speed = 0.3;

            this.keyboardSpeed1 = 0;
            this.keyboardSpeed2 = 0;
            this.keyDownList = [];

            this.life = 100;

            this.RockerView = null;
            this.TranslateView = null;
            this.isAim = false;

            this.state = "";
        }

        onEnable() {
            this.player = this.owner;
            console.log(this.player.getChildByName("Camera").getChildByName("role1"));
            this.name = this.player.name;
            GameManager.Camera = this.player.getChildByName("Camera");
            this.playerAni = this.player.getChildByName("Camera").getChildByName("role1").getComponent(Laya.Animator);
            this.cameraAni = this.player.getChildByName("Camera").getChildByName("Camera").getComponent(Laya.Animator);
            this.Init();
            this.listenKeyboard();
            GameManager.canShoot = true;
            this.play("idle");
        }

        play(aniName) {
            if (this.state != "magazine") {
                if (this.state != aniName) {
                    this.playerAni.crossFade(aniName, 0.2, 0);
                    this.state = aniName;
                }
            }
        }

        playAttack(aniName) {
            if (aniName == "aim_attack1") {
                this.playerAni.crossFade(aniName, 0.2, 0);
                this.state = aniName;
            } else {
                if (this.state != aniName) {
                    this.playerAni.crossFade(aniName, 0.2, 0);
                    this.state = aniName;
                }
            }
        }

        Init() {
            //为精灵添加角色控制器
            var character = this.player.addComponent(Laya.CharacterController);
            //创建胶囊碰撞器
            var sphereShape = new Laya.CapsuleColliderShape(0.5, 1.7);
            //设置Shape的本地偏移
            sphereShape.localOffset = new Laya.Vector3(0, 0.8, 0.19);
            //设置角色控制器的碰撞形状
            character.colliderShape = sphereShape;

            for (var key in GameData.JSONData) {
                this.player.getChildByName("Camera").getChildByName("role1").getChildByName(GameData.JSONData[key].modeName).active = false;
            }
        }

        Aim() {
            if (this.isAim) {
                this.isAim = false;
                this.cameraAni.crossFade("close", 0.2, 0);
                clearInterval(GameManager.moveCameraTimer);
                GameManager.moveCameraTimer = setInterval(() => {
                    if (GameManager.gameScene != null) {
                        this.player.getChildByName("Camera").getChildByName("Camera").fieldOfView++;
                        if (this.player.getChildByName("Camera").getChildByName("Camera").fieldOfView >= 70) {
                            clearInterval(GameManager.moveCameraTimer);
                        }
                    }
                }, 1);
            } else {
                this.isAim = true;
                this.cameraAni.crossFade("open", 0.2, 0);
                clearInterval(GameManager.moveCameraTimer);
                GameManager.moveCameraTimer = setInterval(() => {
                    if (GameManager.gameScene != null) {
                        this.player.getChildByName("Camera").getChildByName("Camera").fieldOfView--;
                        if (this.player.getChildByName("Camera").getChildByName("Camera").fieldOfView <= 30) {
                            clearInterval(GameManager.moveCameraTimer);
                        }
                    }
                }, 1);
            }
        }

        choseArm(armID) {
            for (var key in GameData.JSONData) {
                this.player.getChildByName("Camera").getChildByName("role1").getChildByName(GameData.JSONData[key].modeName).active = false;
            }

            console.log(armID);
            console.log(GameData.JSONData[armID].modeName);
            console.log(GameData.JSONData);

            var armModel = this.player.getChildByName("Camera").getChildByName("role1").getChildByName(GameData.JSONData[armID].modeName);
            armModel.active = true;
            this.armJS = armModel.addComponent(Arm);
            this.armJSON = GameData.searchJSONData(this.armJS.name);
            this.armJS.Init(this.armJSON.bulletNum, this.armJSON.speed, this.armJSON.harm);

            if (armID == 5) {
                if (GameManager.gameScene != null) {
                    GameManager.gameScene.fireTypeBtn.visible = false;
                } else {
                    GameManager.gameScene.fireTypeBtn.visible = true;
                }
            }
        }

        listenKeyboard() {
            console.log("设置键盘监听事件");
            //添加键盘按下事件,一直按着某按键则会不断触发
            Laya.stage.on(Laya.Event.KEY_DOWN, this, this.onKeyDown);
            //添加键盘抬起事件
            Laya.stage.on(Laya.Event.KEY_UP, this, this.onKeyUp);
        }

        onKeyDown(e) {
            this.keyDownList[e["keyCode"]] = true;
        }

        onKeyUp(e) {
            delete this.keyDownList[e["keyCode"]];
        }

        Revive() {
            var playlocalPosition = GameManager.player.transform.localPosition;
            var playlocalRotation = GameManager.player.transform.localRotation;
            GameManager.player.destroy();

            var playerModel = GameManager.Model.getChildByName("role1");
            GameManager.player = Laya.Sprite3D.instantiate(playerModel, GameManager.playBornPoint);
            GameManager.player.transform.localPosition = playlocalPosition;
            GameManager.player.transform.localRotation = playlocalRotation;
            GameManager.playerJS = GameManager.player.addComponent(Player);
            GameManager.gameScene.InitReadyList();
            GameManager.isPause = true;
            this.life = 100;
        }

        Move() {
            if (!this.keyDownList[38] && !this.keyDownList[40] && !this.keyDownList[83] && !this.keyDownList[87] && !this.keyDownList[37] && !this.keyDownList[39] && !this.keyDownList[65] && !this.keyDownList[68]) {
                if (this.RockerView.angle) {
                    if (this.RockerView.angle != -1) {
                        var speedX = Math.sin(this.RockerView.radians);
                        var speedZ = Math.cos(this.RockerView.radians);
                        this.player.transform.translate(new Laya.Vector3(-speedX * this.speed, 0, -speedZ * this.speed), true);
                    } else {
                        this.player.transform.translate(new Laya.Vector3(0, 0, 0), true);
                    }
                } else {
                    this.player.transform.translate(new Laya.Vector3(0, 0, 0), true);
                }
            } else {
                if (!this.keyDownList[38] && !this.keyDownList[40] && !this.keyDownList[83] && !this.keyDownList[87]) {
                    this.keyboardSpeed1 = 0;
                } else {
                    if (this.keyDownList[38] || this.keyDownList[87]) {
                        this.keyboardSpeed1 = 1;
                    }
                    if (this.keyDownList[83] || this.keyDownList[40]) {
                        this.keyboardSpeed1 = -1;
                    }
                }

                if (!this.keyDownList[37] && !this.keyDownList[39] && !this.keyDownList[65] && !this.keyDownList[68]) {
                    this.keyboardSpeed2 = 0;
                } else {
                    if (this.keyDownList[65] || this.keyDownList[37]) {
                        this.keyboardSpeed2 = 1;
                    }
                    if (this.keyDownList[68] || this.keyDownList[39]) {
                        this.keyboardSpeed2 = -1;
                    }
                }

                this.player.transform.translate(new Laya.Vector3(this.keyboardSpeed2 * this.speed, 0, this.keyboardSpeed1 * this.speed), true);
            }
        }

        onShoot_one() {
            if (this.state != "magazine") {
                if (this.armJS != null) {
                    if (this.armJSON != null) {
                        if (this.armJS.nowBullet > 0) {
                            if (GameManager.canShoot) {
                                GameManager.canShoot = false;
                                this.armJS.onShoot_one("bulletPlayer_" + this.armJSON.harm);
                                this.playAttack("aim_attack1");
                                var hitName = GameManager.createRay_player(this.armJSON.shootDis);
                                if (hitName != null) {
                                    var npcjs = GameManager.getNPCJS(hitName);
                                    // console.log("npcjs:", npcjs);
                                    if (npcjs != null) {
                                        npcjs.getHarm(this.armJSON.harm);
                                    }
                                }
                                var speed = this.armJSON.speed;
                                if (speed == 0) {
                                    speed = 1000;
                                }
                                setTimeout(() => {
                                    GameManager.canShoot = true;
                                }, speed);
                            }
                        } else {
                            // console.log("请换弹夹");
                            // if (GameManager.gameScene != null) {
                            //     GameManager.gameScene.tip.visible = true;
                            //     setTimeout(() => {
                            //         if (GameManager.gameScene != null) {
                            //             GameManager.gameScene.tip.visible = false;
                            //         }
                            //     }, 1000);
                            // }
                            this.magazine();
                        }
                    }
                }
            }
        }

        onShoot_more() {
            if (this.state != "magazine") {
                if (this.armJS != null) {
                    if (this.armJSON != null) {
                        if (this.armJS.nowBullet > 0) {
                            this.armJS.onShoot_one("bulletPlayer_" + this.armJSON.harm);
                            this.playAttack("aim_attack2");
                            var hitName = GameManager.createRay_player(this.armJSON.shootDis);
                            if (hitName != null) {
                                var npcjs = GameManager.getNPCJS(hitName);
                                if (npcjs != null) {
                                    npcjs.getHarm(this.armJSON.harm);
                                }
                            }
                            var random = GameManager.Random(0, 1);
                            if (random == 0) {
                                random = -1;
                            } else {
                                random = 1;
                            }
                            GameManager.Camera.transform.rotate(new Laya.Vector3(-0.02, 0.3 * random, 0), true, false);
                        } else {
                            // console.log("请换弹夹");
                            // this.play("idle");
                            // if (GameManager.gameScene != null) {
                            //     clearTimeout(GameManager.showTipTimer);
                            //     GameManager.gameScene.tip.visible = true;
                            //     GameManager.showTipTimer = setTimeout(() => {
                            //         if (GameManager.gameScene != null) {
                            //             GameManager.gameScene.tip.visible = false;
                            //         }
                            //     }, 1000);
                            // }
                            this.magazine();
                        }
                    }
                }
            }
        }

        magazine() {
            GameManager.PlaySound("magazine");
            this.playAttack("magazine");
            setTimeout(() => {
                this.state = "";
                this.play("idle");
                this.armJS.nowBullet = this.armJS.bulletNum;
            }, 1100);
        }

        onUpdate() {
            if (!GameManager.isPause) {
                if (GameManager.gameScene != null) {
                    if (GameManager.gameScene.readyUI.visible) {
                        if (this.RockerView != null) {
                            this.RockerView.destroy();
                            this.RockerView = null;
                        }

                        if (this.TranslateView != null) {
                            this.TranslateView.destroy();
                            this.TranslateView = null;
                        }
                    } else {
                        if (this.RockerView == null) {
                            this.RockerView = Laya.stage.addChild(new RockerView());
                        }
                        if (this.TranslateView == null) {
                            this.TranslateView = Laya.stage.addChild(new TranslateView());
                        }
                        this.Move();
                    }
                }
            } else {
                if (this.RockerView != null) {
                    this.RockerView.destroy();
                    this.RockerView = null;
                }

                if (this.TranslateView != null) {
                    this.TranslateView.destroy();
                    this.TranslateView = null;
                }
            }
        }

        onDisable() {
            if (this.RockerView != null) {
                this.RockerView.destroy();
            }

            if (this.TranslateView != null) {
                this.TranslateView.destroy();
            }

            if (GameManager.gameScene != null) {
                GameManager.gameScene.ani2.play(0, false);
            }
        }
    }

    class mainScene extends Laya.Scene {

        constructor() {
            super();
            this.loadValue = 0;
            this.updateLoadValue = 0;
        }

        onEnable() {
            if (window.android) {
                this.logo.skin = SDK_apk.logoUrl;

                var jpgIndex = SDK_apk.random(0, SDK_apk.getJPGNum_main() - 1);
                console.log("jpgIndex:" + jpgIndex);
                var JPGbg = new Laya.Image(SDK_apk.getJPGUrl_main(jpgIndex));
                JPGbg.zOrder = -1;
                JPGbg.centerX = 0;
                JPGbg.centerY = 0;
                this.addChild(JPGbg);
            }

            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
            this.startBtn.on(Laya.Event.CLICK, this, this.clickStart);
            this.ageBtn.on(Laya.Event.CLICK, this, function () {
                SDK_apk.showNotice();
            });

            GameManager.PlayMusic("bgm");
        }

        onOpened(isGo) {
            if (isGo) {
                this.clickStart();
            }
        }

        clickStart() {
            this.loadScene();
            this.loadingUI.visible = true;
            Laya.timer.loop(1, this, this.update);
        }

        loadScene() {
            this.resource = [
                "res/Unity/LayaScene_Scene1/Conventional/Scene1.ls",
                "res/Unity/LayaScene_Object_Green/Conventional/Object_Green.lh",
            ];
            Laya.loader.create(this.resource, Laya.Handler.create(this, this.onPreLoadFinish),
                Laya.Handler.create(this, function (value) {
                    this.loadValue = value;
                })
            );
        }

        onPreLoadFinish() {
            GameManager.CameraJS = null;
            GameManager.playerJS = null;
            GameManager.npcBornPointJS = [];
            GameManager.npcJS = [];
            GameManager.hasPlayedSound = [];
            GameManager.canShoot = true;

            GameManager.areaNum = [8, 8, 8, 8];
            GameManager.isAim = false;
            GameManager.hitProbability = 10;
            GameManager.noHarm = false;
            GameManager.allNum = 0;

            GameManager.npcJS = [];
            GameManager.npcBornPoint = [];
            GameManager.playBornPoint = null;
            GameManager.resScene = Laya.Loader.getRes("res/Unity/LayaScene_Scene1/Conventional/Scene1.ls");
            console.log(GameManager.resScene);
            GameManager.Model = Laya.Loader.getRes("res/Unity/LayaScene_Object_Green/Conventional/Object_Green.lh");
            GameManager.Scene = Laya.stage.addChildAt(GameManager.resScene, 0);

            GameManager.playBornPoint = GameManager.Scene.getChildByName("Born_0");
            var playerModel = GameManager.Model.getChildByName("role1");
            GameManager.player = Laya.Sprite3D.instantiate(playerModel, GameManager.playBornPoint);
            GameManager.player.transform.localPosition = new Laya.Vector3(0, 0, 0);
            GameManager.player.transform.localRotation = GameManager.playBornPoint.transform.localRotation;
            GameManager.playerJS = GameManager.player.addComponent(Player);

            var npcBornPoint = GameManager.Scene.getChildByName("npc")._children;
            for (var key in npcBornPoint) {
                var npcBornPointJS = npcBornPoint[key].addComponent(NPCBornPoint);
                GameManager.npcBornPointJS.push(npcBornPointJS);
            }
        }

        update() {
            this.updateLoadValue += 0.01;
            if (this.updateLoadValue > this.loadValue) {
                this.updateLoadValue = this.loadValue;
            }
            this.loadBar.value = this.updateLoadValue;
            if (this.loadBar.value >= 1) {
                Laya.timer.clear(this, this.update);
                Laya.Scene.open("scene/gameScene.scene");
            }
        }

        onDisable() {

        }
    }

    /**This class is automatically generated by LayaAirIDE, please do not make any modifications. */

    class GameConfig {
        static init() {
            //注册Script或者Runtime引用
            let reg = Laya.ClassUtils.regClass;
    		reg("script/gameScene.js",gameScene);
    		reg("script/harmUI.js",harmUI);
    		reg("script/loadingScene.js",loadingScene);
    		reg("script/mainScene.js",mainScene);
        }
    }
    GameConfig.width = 1280;
    GameConfig.height = 720;
    GameConfig.scaleMode ="fixedheight";
    GameConfig.screenMode = "horizontal";
    GameConfig.alignV = "middle";
    GameConfig.alignH = "center";
    GameConfig.startScene = "scene/loadingScene.scene";
    GameConfig.sceneRoot = "";
    GameConfig.debug = false;
    GameConfig.stat = false;
    GameConfig.physicsDebug = false;
    GameConfig.exportSceneToJson = true;

    GameConfig.init();

    class Main {
    	constructor() {
    		SDK_apk.getLogoUrl();
    		//根据IDE设置初始化引擎		
    		if (window["Laya3D"]) Laya3D.init(GameConfig.width, GameConfig.height);
    		else Laya.init(GameConfig.width, GameConfig.height, Laya["WebGL"]);
    		Laya["Physics"] && Laya["Physics"].enable();
    		Laya["DebugPanel"] && Laya["DebugPanel"].enable();
    		Laya.stage.scaleMode = GameConfig.scaleMode;
    		Laya.stage.screenMode = GameConfig.screenMode;
    		Laya.stage.alignV = GameConfig.alignV;
    		Laya.stage.alignH = GameConfig.alignH;
    		//兼容微信不支持加载scene后缀场景
    		Laya.URL.exportSceneToJson = GameConfig.exportSceneToJson;

    		//打开调试面板（通过IDE设置调试模式，或者url地址增加debug=true参数，均可打开调试面板）
    		if (GameConfig.debug || Laya.Utils.getQueryString("debug") == "true") Laya.enableDebugPanel();
    		if (GameConfig.physicsDebug && Laya["PhysicsDebugDraw"]) Laya["PhysicsDebugDraw"].enable();
    		if (GameConfig.stat) Laya.Stat.show();
    		Laya.alertGlobalError(true);

    		//激活资源版本控制，version.json由IDE发布功能自动生成，如果没有也不影响后续流程
    		Laya.ResourceVersion.enable("version.json", Laya.Handler.create(this, this.onVersionLoaded), Laya.ResourceVersion.FILENAME_VERSION);
    	}

    	onVersionLoaded() {
    		//激活大小图映射，加载小图的时候，如果发现小图在大图合集里面，则优先加载大图合集，而不是小图
    		Laya.AtlasInfoManager.enable("fileconfig.json", Laya.Handler.create(this, this.onConfigLoaded));
    	}

    	onConfigLoaded() {
    		//加载IDE指定的场景
    		GameConfig.startScene && Laya.Scene.open(GameConfig.startScene);
    	}
    }
    //激活启动类
    new Main();

}());
